#include "Serialize.hpp"

#ifndef PSF_PARTIAL_ORDERING_OF_TEMPLATES

// POD Serializers
void PSF::Serialize( const char& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const unsigned char& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const short& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const unsigned short& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const int& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const unsigned int& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const long& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const unsigned long& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const float& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const double& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const bool& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}

void PSF::Serialize( const wchar_t& i_in, ISerializer& i_serializer)
{
	i_serializer.Serialize( i_in);
}




void PSF::Serialize( const char& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(char))));
}

void PSF::Serialize( const unsigned char& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned char))));
}

void PSF::Serialize( const short& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(short))));
}

void PSF::Serialize( const unsigned short& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned short))));
}

void PSF::Serialize( const int& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(int))));
}

void PSF::Serialize( const unsigned int& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned int))));
}

void PSF::Serialize( const long& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(long))));
}

void PSF::Serialize( const unsigned long& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(unsigned long))));
}

void PSF::Serialize( const float& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(float))));
}

void PSF::Serialize( const double& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(double))));
}

void PSF::Serialize( const bool& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(bool))));
}

void PSF::Serialize( const wchar_t& i_in, ISerializer& i_serializer, const std::wstring& i_wstrName)
{
	Serialize( i_in, *i_serializer.SerializeCompound( i_wstrName, Loki::TypeInfo(typeid(wchar_t))));
}
#endif